diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/.depend ircd-hybrid-fuis/modules/.depend
--- ircd-hybrid-7.0rc9/modules/.depend	Thu Jan 30 05:28:47 2003
+++ ircd-hybrid-fuis/modules/.depend	Wed Mar 12 16:25:35 2003
@@ -1,4 +1,4 @@
-m_die.o: core/m_die.c ../include/stdinc.h ../include/config.h \
+m_die.o: m_die.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/client.h ../include/ircd_defs.h \
   ../include/ircd_handler.h ../include/linebuf.h ../include/channel.h \
@@ -8,7 +8,7 @@
   ../include/s_bsd.h ../include/s_log.h ../include/s_conf.h \
   ../include/motd.h ../include/class.h ../include/send.h ../include/msg.h \
   ../include/parse.h ../include/modules.h
-m_kick.o: core/m_kick.c ../include/stdinc.h ../include/config.h \
+m_kick.o: m_kick.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/channel.h ../include/ircd_defs.h \
   ../include/channel_mode.h ../include/vchannel.h ../include/client.h \
@@ -18,7 +18,7 @@
   ../include/sprintf_irc.h ../include/numeric.h ../include/send.h \
   ../include/msg.h ../include/modules.h ../include/parse.h \
   ../include/hash.h ../include/packet.h ../include/fdlist.h
-m_kill.o: core/m_kill.c ../include/stdinc.h ../include/config.h \
+m_kill.o: m_kill.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/handlers.h \
   ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
   ../include/linebuf.h ../include/tools.h ../include/channel.h \
@@ -29,7 +29,7 @@
   ../include/motd.h ../include/class.h ../include/send.h \
   ../include/whowas.h ../include/msg.h ../include/parse.h \
   ../include/modules.h
-m_message.o: core/m_message.c ../include/stdinc.h ../include/config.h \
+m_message.o: m_message.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/handlers.h \
   ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
   ../include/linebuf.h ../include/tools.h ../include/channel.h \
@@ -41,7 +41,7 @@
   ../include/parse.h ../include/modules.h ../include/channel_mode.h \
   ../include/vchannel.h ../include/hash.h ../include/packet.h \
   ../include/fdlist.h
-m_mode.o: core/m_mode.c ../include/stdinc.h ../include/config.h \
+m_mode.o: m_mode.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/channel.h ../include/ircd_defs.h \
   ../include/channel_mode.h ../include/vchannel.h ../include/client.h \
@@ -53,7 +53,7 @@
   ../include/class.h ../include/s_serv.h ../include/send.h \
   ../include/msg.h ../include/parse.h ../include/modules.h \
   ../include/packet.h ../include/fdlist.h
-m_nick.o: core/m_nick.c ../include/stdinc.h ../include/config.h \
+m_nick.o: m_nick.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/handlers.h \
   ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
   ../include/linebuf.h ../include/tools.h ../include/channel.h \
@@ -66,7 +66,7 @@
   ../include/list.h ../include/s_log.h ../include/resv.h ../include/msg.h \
   ../include/parse.h ../include/modules.h ../include/common.h \
   ../include/packet.h
-m_part.o: core/m_part.c ../include/stdinc.h ../include/config.h \
+m_part.o: m_part.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/channel.h ../include/ircd_defs.h \
   ../include/vchannel.h ../include/client.h ../include/ircd_handler.h \
@@ -78,7 +78,7 @@
   ../include/msg.h ../include/parse.h ../include/modules.h \
   ../include/s_conf.h ../include/motd.h ../include/class.h \
   ../include/packet.h ../include/fdlist.h
-m_quit.o: core/m_quit.c ../include/stdinc.h ../include/config.h \
+m_quit.o: m_quit.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/handlers.h \
   ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
   ../include/linebuf.h ../include/tools.h ../include/channel.h \
@@ -88,7 +88,7 @@
   ../include/send.h ../include/msg.h ../include/parse.h \
   ../include/modules.h ../include/s_conf.h ../include/motd.h \
   ../include/class.h
-m_server.o: core/m_server.c ../include/stdinc.h ../include/config.h \
+m_server.o: m_server.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/client.h ../include/ircd_defs.h \
   ../include/ircd_handler.h ../include/linebuf.h ../include/channel.h \
@@ -100,7 +100,7 @@
   ../include/s_log.h ../include/s_serv.h ../include/s_stats.h \
   ../include/scache.h ../include/send.h ../include/msg.h \
   ../include/parse.h ../include/modules.h
-m_sjoin.o: core/m_sjoin.c ../include/stdinc.h ../include/config.h \
+m_sjoin.o: m_sjoin.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
   ../include/handlers.h ../include/channel.h ../include/ircd_defs.h \
   ../include/channel_mode.h ../include/vchannel.h ../include/client.h \
@@ -112,7 +112,7 @@
   ../include/msg.h ../include/parse.h ../include/modules.h \
   ../include/s_serv.h ../include/s_conf.h ../include/motd.h \
   ../include/class.h
-m_squit.o: core/m_squit.c ../include/stdinc.h ../include/config.h \
+m_squit.o: m_squit.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/handlers.h \
   ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
   ../include/linebuf.h ../include/tools.h ../include/channel.h \
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_admin.c ircd-hybrid-fuis/modules/m_admin.c
--- ircd-hybrid-7.0rc9/modules/m_admin.c	Wed Jul 31 12:24:06 2002
+++ ircd-hybrid-fuis/modules/m_admin.c	Tue Feb 11 08:20:42 2003
@@ -50,14 +50,12 @@
 void
 _modinit(void)
 {
-  hook_add_event("doing_admin");
   mod_add_cmd(&admin_msgtab);
 }
 
 void
 _moddeinit(void)
 {
-  hook_del_event("doing_admin");
   mod_del_cmd(&admin_msgtab);
 }
 const char *_version = "$Revision: 1.35 $";
@@ -166,9 +164,8 @@
  */
 static void admin_spy(struct Client *source_p)
 {
-  struct hook_spy_data data;
-
-  data.source_p = source_p;
-
-  hook_call_event("doing_admin", &data);
+  sendto_realops_flags(FLAGS_SPY, L_ALL,
+          "admin requested by %s (%s@%s) [%s]",
+          source_p->name, source_p->username,
+		  source_p->host, source_p->user->server);
 }
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_die.c ircd-hybrid-fuis/modules/m_die.c
--- ircd-hybrid-7.0rc9/modules/m_die.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_die.c	Fri Jan 24 02:01:59 2003
@@ -0,0 +1,124 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_die.c: Kills off this server.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_die.c,v 1.25 2003/01/24 07:01:59 lusky Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_log.h"
+#include "s_conf.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void mo_die(struct Client*, struct Client*, int, char**);
+
+struct Message die_msgtab = {
+  "DIE", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, m_ignore, mo_die}
+};
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&die_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&die_msgtab);
+}
+
+const char *_version = "$Revision: 1.25 $";
+#endif
+/*
+ * mo_die - DIE command handler
+ */
+static void mo_die(struct Client *client_p, struct Client *source_p,
+                  int parc, char *parv[])
+{
+  struct Client* target_p;
+  dlink_node *ptr;
+
+  if (!IsOperDie(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need die = yes;", me.name, parv[0]);
+      return;
+    }
+
+  if (parc < 2)
+    {
+      sendto_one(source_p,":%s NOTICE %s :Need server name /die %s",
+                 me.name,source_p->name,me.name);
+      return;
+    }
+  else
+    {
+      if (irccmp(parv[1], me.name))
+        {
+          sendto_one(source_p,":%s NOTICE %s :Mismatch on /die %s",
+                     me.name,source_p->name,me.name);
+          return;
+        }
+    }
+
+  for(ptr = lclient_list.head; ptr; ptr = ptr->next)
+    {
+      target_p = ptr->data;
+
+      sendto_one(target_p,
+		 ":%s NOTICE %s :Server Terminating. %s",
+		 me.name, target_p->name,
+		 get_client_name(source_p, HIDE_IP));
+    }
+
+  for(ptr = serv_list.head; ptr; ptr = ptr->next)
+    {
+      target_p = ptr->data;
+
+      sendto_one(target_p, ":%s ERROR :Terminated by %s",
+		 me.name, get_client_name(source_p, HIDE_IP));
+    }
+
+  /*
+   * XXX we called flush_connections() here. Read server_reboot()
+   * for an explanation as to what we should do.
+   *     -- adrian
+   */
+  ilog(L_NOTICE, "Server terminated by %s", get_oper_name(source_p));
+  /* 
+   * this is a normal exit, tell the os it's ok 
+   */
+  unlink(pidFileName);
+  exit(0);
+  /* NOT REACHED */
+}
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_dmem.c ircd-hybrid-fuis/modules/m_dmem.c
--- ircd-hybrid-7.0rc9/modules/m_dmem.c	Fri May 24 19:34:19 2002
+++ ircd-hybrid-fuis/modules/m_dmem.c	Sun Feb 16 21:09:37 2003
@@ -30,7 +30,6 @@
 #include "ircd.h"
 #include "ircd_defs.h"
 #include "list.h"
-#include "s_gline.h"
 #include "numeric.h"
 #include "res.h"
 #include "s_conf.h"
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_info.c ircd-hybrid-fuis/modules/m_info.c
--- ircd-hybrid-7.0rc9/modules/m_info.c	Mon Oct 28 16:09:21 2002
+++ ircd-hybrid-fuis/modules/m_info.c	Sun Feb 16 21:09:37 2003
@@ -168,19 +168,7 @@
     &ConfigFileEntry.fname_userlog,
     "User log file"
   },
-  {
-    "glines",
-    OUTPUT_BOOLEAN,
-    &ConfigFileEntry.glines,
-    "G-line (network-wide K-line) support"
-  },
-  {
-    "gline_time",
-    OUTPUT_DECIMAL,
-    &ConfigFileEntry.gline_time,
-    "Expiry time for G-lines"
-  },
-  {
+{
     "hub",
     OUTPUT_BOOLEAN_YN,
     &ServerInfo.hub,
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_invite.c ircd-hybrid-fuis/modules/m_invite.c
--- ircd-hybrid-7.0rc9/modules/m_invite.c	Wed Jan 22 23:24:06 2003
+++ ircd-hybrid-fuis/modules/m_invite.c	Sun Feb  9 08:21:20 2003
@@ -196,6 +196,16 @@
 
   if (MyConnect(source_p))
   {
+	if (ServicesOn && HasSilence(target_p) && (target_p != source_p) &&
+		!IsOper(target_p) && (!IsNSId(source_p) ||
+		source_p->ns_reg + ConfigFileEntry.how_old >= CurrentTime))
+	{
+	  sendto_one(source_p, ":%s NOTICE %s :Error: %s is in silence mode and does NOT accept invites from unregistered/unidentified (too recently registered) nicknames",
+				 me.name, parv[0], target_p->name);
+	  sendto_one(source_p, ":%s NOTICE %s :Error: If you want to invite %s you will have to identify or register your nickname",
+				 me.name, parv[0], target_p->name);
+	  return;
+	}
     sendto_one(source_p, form_str(RPL_INVITING), me.name, parv[0],
                target_p->name, parv[2]);
     if (target_p->user->away)
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_ison.c ircd-hybrid-fuis/modules/m_ison.c
--- ircd-hybrid-7.0rc9/modules/m_ison.c	Fri May 24 19:34:20 2002
+++ ircd-hybrid-fuis/modules/m_ison.c	Sun Feb  9 08:21:20 2003
@@ -82,6 +82,9 @@
 {
   struct Client *up = NULL;
 
+  if (client_p->user)
+    client_p->user->known = 1;
+
   if (!ServerInfo.hub && uplink && IsCapable(uplink, CAP_LL))
     up = uplink;
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_join.c ircd-hybrid-fuis/modules/m_join.c
--- ircd-hybrid-7.0rc9/modules/m_join.c	Sat Feb  1 15:11:45 2003
+++ ircd-hybrid-fuis/modules/m_join.c	Wed Mar 12 16:24:46 2003
@@ -108,6 +108,11 @@
       return;
     }
 
+  if (!irccmp(parv[1], "#help"))
+  {
+	parv[1] = "#irchelp";
+  }
+
 #ifdef VCHANS
   if (parc > 3)
     {
@@ -283,11 +288,17 @@
     if (!IsOper(source_p))
      check_spambot_warning(source_p, name);
       
+    if ((chptr->mode.mode & MODE_JOINF) && ServicesOn && (!IsNSId(source_p) ||
+	    (source_p->ns_reg + ConfigFileEntry.how_old >= time(NULL))) && !IsOperRemote(source_p)) {
+	  sendto_one(source_p, form_str(ERR_JOINF), me.name, source_p->name, chptr->chname);
+	  return;
+	}
+
       /*
        * can_join checks for +i key, bans.
        */
 
-      if ((i = can_join(source_p, chptr, key)))
+      if ((i = can_join(source_p, chptr, key)) && !IsOperRemote(source_p))
 	{
 	  sendto_one(source_p, form_str(i), me.name, parv[0], name);
 	  successful_join_count++;
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_kick.c ircd-hybrid-fuis/modules/m_kick.c
--- ircd-hybrid-7.0rc9/modules/m_kick.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_kick.c	Sun May  4 18:19:38 2003
@@ -0,0 +1,296 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_kick.c: Kicks a user from a channel.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_kick.c,v 1.50 2003/02/01 20:12:24 db Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "common.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "vchannel.h"
+#include "hash.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "send.h"
+#include "list.h"
+#include "irc_string.h"
+#include "s_conf.h"
+#include "msg.h"
+#include "packet.h"
+#include "parse.h"
+#include "modules.h"
+#include "hook.h"
+#include "resv.h"
+
+static void m_kick(struct Client*, struct Client*, int, char**);
+static void ms_kick(struct Client*, struct Client*, int, char**);
+
+struct Message kick_msgtab = {
+  "KICK", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_kick, ms_kick, m_kick}
+};
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&kick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&kick_msgtab);
+}
+
+const char *_version = "$Revision: 1.50 $";
+#endif
+/*
+** m_kick
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = client to kick
+**      parv[3] = kick comment
+*/
+static void 
+m_kick(struct Client *client_p, struct Client *source_p,
+                  int parc, char *parv[])
+{
+  struct ResvNick *resv;
+  struct Client *who;
+  struct Channel *chptr;
+#ifdef VCHANS
+  struct Channel *vchan;
+#endif
+  int   chasing = 0;
+  char  *comment;
+  char  *name;
+  char  *p = (char *)NULL;
+  char  *user;
+  dlink_node *ptr;
+  static char     buf[BUFSIZE];
+
+  if (*parv[2] == '\0')
+    {
+      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "KICK");
+      return;
+    }
+
+  if(MyClient(source_p) && !IsFloodDone(source_p))
+    flood_endgrace(source_p);
+
+  comment = (BadPtr(parv[3])) ? parv[2] : parv[3];
+  if (strlen(comment) > (size_t) TOPICLEN)
+    comment[TOPICLEN] = '\0';
+
+  *buf = '\0';
+  name = parv[1];
+  while (*name == ',')
+    name++;
+  if((p = strchr(name,',')) != NULL)
+    *p = '\0';
+  if (!*name)
+    return;
+
+  chptr = hash_find_channel(name);
+  if (!chptr)
+    {
+      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+                 me.name, parv[0], name);
+      return;
+    }
+
+#ifdef VCHANS
+  if (HasVchans(chptr))
+    {
+      vchan = map_vchan(chptr,source_p);
+      if(vchan != 0)
+	{
+	  chptr = vchan;
+	}
+    }
+#endif
+
+  if (!IsServer(source_p) && !is_any_op(chptr, source_p)) 
+    { 
+	  if (IsOperRemote(source_p) && !ServicesOn) {
+		sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to kick %s out of %s",
+						     source_p->name, parv[2], chptr);
+	  } else {
+      /* was a user, not a server, and user isn't seen as a chanop here */
+      
+      if(MyConnect(source_p))
+        {
+          /* user on _my_ server, with no chanops.. so go away */
+          
+          sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+                     me.name, parv[0], name);
+          return;
+        }
+
+      if(chptr->channelts == 0)
+        {
+          /* If its a TS 0 channel, do it the old way */
+          
+          sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+                     me.name, parv[0], name);
+          return;
+        }
+
+      /* Its a user doing a kick, but is not showing as chanop locally
+       * its also not a user ON -my- server, and the channel has a TS.
+       * There are two cases we can get to this point then...
+       *
+       *     1) connect burst is happening, and for some reason a legit
+       *        op has sent a KICK, but the SJOIN hasn't happened yet or 
+       *        been seen. (who knows.. due to lag...)
+       *
+       *     2) The channel is desynced. That can STILL happen with TS
+       *        
+       *     Now, the old code roger wrote, would allow the KICK to 
+       *     go through. Thats quite legit, but lets weird things like
+       *     KICKS by users who appear not to be chanopped happen,
+       *     or even neater, they appear not to be on the channel.
+       *     This fits every definition of a desync, doesn't it? ;-)
+       *     So I will allow the KICK, otherwise, things are MUCH worse.
+       *     But I will warn it as a possible desync.
+       *
+       *     -Dianora
+       */
+	   }
+    }
+
+  user = parv[2];
+  while (*user == ',')
+    user++;
+  if((p = strchr(user,',')) != NULL)
+    *p = '\0';
+  if (!*user)
+    return;
+
+  if (!(who = find_chasing(source_p, user, &chasing)))
+    {
+      return;
+    }
+
+  if (MyClient(source_p) && (resv = return_nick_resv(who->name)) && !irccmp(resv->reason, ConfigFileEntry.services_qline))
+  {
+    sendto_one(source_p, form_str(ERR_SERVICESNICKKICK), me.name,
+               who->name, chptr->chname);
+	return;
+  }
+
+  if ((ptr = dlinkFind(&chptr->nokick, who)) != NULL)
+  {
+    sendto_one(source_p, form_str(ERR_NOKICK), me.name,
+               who->name, chptr->chname);
+	return;
+  }
+
+  if (IsMember(who, chptr))
+    {
+      /* half ops cannot kick other halfops on private channels */
+#ifdef HALFOPS
+      if (is_half_op(chptr,source_p))
+      {
+	if (((chptr->mode.mode & MODE_PRIVATE) && is_any_op(chptr, who)) ||
+             is_chan_op(chptr, who))
+	{
+          sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+                     me.name, parv[0], name);
+	  return;
+	}
+      }
+#endif
+      /* jdc
+       * - In the case of a server kicking a user (i.e. CLEARCHAN),
+       *   the kick should show up as coming from the server which did
+       *   the kick.
+       * - Personally, flame and I believe that server kicks shouldn't
+       *   be sent anyways.  Just waiting for some oper to abuse it...
+       */
+      if (IsServer(source_p))
+      {
+        sendto_channel_local(ALL_MEMBERS, chptr, ":%s KICK %s %s :%s",
+          source_p->name, name, who->name, comment);
+      }
+#ifdef ANONOPS
+      else if(chptr->mode.mode & MODE_HIDEOPS)
+	{
+	  /* jdc -- Non-chanops get kicked from me.name, not
+	   *        who->name (themselves).
+	   */
+	  sendto_channel_local(NON_CHANOPS, chptr,
+			       ":%s KICK %s %s :%s",
+			       me.name,
+			       name, who->name, comment);
+
+	  sendto_channel_local(ONLY_CHANOPS_HALFOPS, chptr,
+			       ":%s!%s@%s KICK %s %s :%s",
+			       source_p->name,
+			       source_p->username,
+			       source_p->host,
+			       name,
+			       who->name, comment);
+	}
+      else
+#endif
+	{
+	  sendto_channel_local(ALL_MEMBERS, chptr,
+			       ":%s!%s@%s KICK %s %s :%s",
+			       source_p->name,
+			       source_p->username,
+			       source_p->host,
+			       name, who->name, comment);
+	}
+
+      sendto_server(client_p, NULL, chptr, NOCAPS, NOCAPS, NOFLAGS,
+                    ":%s KICK %s %s :%s",
+                    parv[0], chptr->chname,
+                    who->name, comment);
+      if (!IsDefunct(who))
+	remove_user_from_channel(chptr, who);
+    }
+  else
+    sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL),
+               me.name, parv[0], user, name);
+}
+
+static void
+ms_kick(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+  if (*parv[2] == '\0')
+    {
+      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "KICK");
+      return;
+    }
+
+  m_kick(client_p, source_p, parc, parv);
+}
